local PopupDialogScreen = require "screens/popupdialog"
local unpack = _G.unpack

local Outcomes = use "outcomes"
local Strings = use "strings"

local _M = {}


local function dialogConstructor(name, handlers)
	local S = Strings[name]

	return function(player, data)
		local function bind(fn)
			return function()
				_G.TheFrontEnd:PopScreen()
				_G.SetPause(false)
				return fn(player, data)
			end
		end

		local buttons = {}
		for i, v in ipairs(S.CHOICES) do
			if not handlers.is_valid[v] or handlers.is_valid[v](player, data) then
				table.insert(buttons, {
					text = S.CHOICES[v],
					cb = bind(handlers[v]),
				})
			end
		end

		_G.SetPause(true)
		_G.TheFrontEnd:PushScreen(PopupDialogScreen(S.TITLE, S.BODY, buttons))
	end
end


_M.Main = dialogConstructor( "MAIN_POPUP", Outcomes.handlers )
_M.Resurrect = dialogConstructor( "RESURRECT_POPUP", Outcomes.handlers.RESURRECT )


return _M
