local DEBUG = false

_G = GLOBAL
require = _G.require
modimport "lib/use.lua"

use "lib.hooks"
local Outcomes = use "outcomes"
local Dialogs = use "dialogs"


local function handle_death(player, data)
	if data.cause == "file_load" or (player.components.resurrectable and player.components.resurrectable:CanResurrect()) then
		return Outcomes.DoDie(player, data)
	else
		return player:DoTaskInTime(3, function(player)
			if player.HUD then
				player.HUD:Hide()
			end
			return Dialogs.Main(player, data)
		end)
	end
end

local function tweak_death_eventlistening(player)
	player:ListenForEvent("death", handle_death)

	player.ListenForEvent = (function()
		local oldListenForEvent = player.ListenForEvent
		return function(self, ev, fn, source)
			if ev == "death" and (not source or source == self) then
				return Outcomes.AddDyingCallback(fn)
			else
				return oldListenForEvent(self, ev, fn, source)
			end
		end
	end)()
end
AddPlayerPrefabPostInit(tweak_death_eventlistening)


if DEBUG then
	function _G.k()
		_G.GetPlayer():DoTaskInTime(3, function(p) p.components.health:Kill() end)
	end
end
